local LDBKaliadMain,LDBKaliadSecondary, i
local DEFAULT_ICON = "Interface\\Icons\\Spell_Shadow_SacrificialShield"
local char, tipshown, f1, f2, f3

LDBKaliadMain = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_KStatsMain", {
	type = "data source",
	icon = DEFAULT_ICON,
	iconCoords = { .08, .92, .08, .92 },
	text = "Kaliad Stats Main",
	label = "Kaliad_Stats_Main",
	OnEnter = function(self)
		local showBelow = select(2, self:GetCenter()) > UIParent:GetHeight()/2
		GameTooltip:SetOwner( self, "ANCHOR_NONE" )
		GameTooltip:SetPoint( showBelow and "TOP" or "BOTTOM", self, showBelow and "BOTTOM" or "TOP" )
		
		
		IntestazionePopUp()
		local ruolo=GetRole("player")
		if ruolo=="HEALER" then	addHealingPopUP() end
		if ruolo=="TANK" then addTankingPopUP() end
		if ruolo=="CASTER" then addCasterPopUP() end
		if ruolo=="MELEE" then addMeleePopUP() end
		if ruolo=="RANGED" then addRangedPopUP() end
				
		tipshown = self
		f1, f2, f3 = GameTooltipTextLeft1:GetFont()
		GameTooltipTextLeft1:SetFont( GameTooltipTextLeft2:GetFont() )
		GameTooltipTextRight1:SetFont( GameTooltipTextLeft2:GetFont() )
		return GameTooltip:Show()
	end,
	OnLeave = function()
		tipshown = nil
		if f1 then
			GameTooltipTextLeft1:SetFont( f1, f2, f3 )
			GameTooltipTextRight1:SetFont( f1, f2, f3 )
		end
		return GameTooltip:Hide()
	end,
	OnClick = function(self, button)
		if IsShiftKeyDown() then
		--	ChatFrame_OpenChat( "/specset ", DEFAULT_CHAT_FRAME )
		elseif IsControlKeyDown() then
		--	ChatFrame_OpenChat( "/specalias "..GetTalentText().." ", DEFAULT_CHAT_FRAME)
		elseif button == "RightButton" then
		--	ToggleTalentFrame()
		elseif button == "MiddleButton" then
		--	char.hideHints = not char.hideHints
		--	if tipshown then block.OnEnter(tipshown) end
		else
			ToggleCharacter("PaperDollFrame")
		end
	end
})

LDBKaliadSecondary = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_KStatsS", {
	type = "data source",
	icon = DEFAULT_ICON,
	iconCoords = { .08, .92, .08, .92 },
	text = "Kaliad Stats Secondary",
	label = "Kaliad_Stats_Secondary",
	OnEnter = function(self)
		local showBelow = select(2, self:GetCenter()) > UIParent:GetHeight()/2
		GameTooltip:SetOwner( self, "ANCHOR_NONE" )
		GameTooltip:SetPoint( showBelow and "TOP" or "BOTTOM", self, showBelow and "BOTTOM" or "TOP" )
		IntestazionePopUp()
		local ruolo=GetRole("player")
		if ruolo=="HEALER" then	addHealingPopUP() end
		if ruolo=="TANK" then addTankingPopUP() end
		if ruolo=="CASTER" then addCasterPopUP() end
		if ruolo=="MELEE" then addMeleePopUP() end
		if ruolo=="RANGED" then addRangedPopUP() end
		tipshown = self
		f1, f2, f3 = GameTooltipTextLeft1:GetFont()
		GameTooltipTextLeft1:SetFont( GameTooltipTextLeft2:GetFont() )
		GameTooltipTextRight1:SetFont( GameTooltipTextLeft2:GetFont() )
		return GameTooltip:Show()
	end,
	OnLeave = function()
		tipshown = nil
		if f1 then
			GameTooltipTextLeft1:SetFont( f1, f2, f3 )
			GameTooltipTextRight1:SetFont( f1, f2, f3 )
		end
		return GameTooltip:Hide()
	end,
	OnClick = function(self, button)
		if IsShiftKeyDown() then
		--	ChatFrame_OpenChat( "/specset ", DEFAULT_CHAT_FRAME )
		elseif IsControlKeyDown() then
		--	ChatFrame_OpenChat( "/specalias "..GetTalentText().." ", DEFAULT_CHAT_FRAME)
		elseif button == "RightButton" then
		--	ToggleTalentFrame()
		elseif button == "MiddleButton" then
		--	char.hideHints = not char.hideHints
		--	if tipshown then block.OnEnter(tipshown) end
		else
			ToggleCharacter("PaperDollFrame")
		end
	end
})


-- FUNZIONE UPDATE per il BROKER PRINCIPALE
local function UpdateStatsM(frame,elapsed)
	
	local valore
	valore="Kaliad Stats"
	
	local ruolo=GetRole("player")
	local etichettaM, iconaM, testoPopupM=readStats(ruolo,"1")
		
	LDBKaliadMain.value = valore 
	LDBKaliadMain.text = etichettaM  
	LDBKaliadMain.icon = iconaM
end
-- FUNZIONE UPDATE per il BROKER SECONDARIO
local function UpdateStatsS(frame,elapsed)
	
	local valore
	valore="Kaliad Stats"
	
	local ruolo=GetRole("player")
	local etichettaS, iconaS, testoPopupS=readStats(ruolo,"2")
	LDBKaliadSecondary.value = valore 
	LDBKaliadSecondary.text = etichettaS   
	LDBKaliadSecondary.icon = iconaS
	
end


-- // FUNZIONE CHE LEGGE IL TESTO DI UNA SPEC
function GetTalentText(group)
	--set = char[GetActiveTalentGroup()].set
	local maxPoints, finalIcon, text
	text="No Assigned Talents"
	maxPoints=0
	
	for tab = 1, 3 do
		local id, name, desc,iconTexture,points,backGround,previewPoints,active = GetTalentTabInfo(tab,nil,nil,group)
		if points > maxPoints then
			maxPoints = points
			finalIcon = iconTexture
			text=name
		end
		--format("%s%.2i", text and text.."/" or "", points)
	end
	return text, finalIcon
end
-- // FUNZIONE CHE CONTROLLA LA SPEC ATTIVA E DECIDE SE SONO 
-- // HEALER, TANK, MELEE, RANGED, CASTER
function GetRole(id)
	local actualRole="Errore!"
	local spec=GetTalentText(GetActiveTalentGroup())
	local classe=UnitClass(id)
	if classe=="Paladin" then if spec=="Protection" then actualRole="TANK" end end
	if classe=="Paladin" then if spec=="Holy" then actualRole="HEALER" end end
	if classe=="Paladin" then if spec=="Retribution" then actualRole="MELEE" end end
	
	if classe=="Priest" then if spec=="Discipline" then actualRole="HEALER" end end
	if classe=="Priest" then if spec=="Holy" then actualRole="HEALER" end end
	if classe=="Priest" then if spec=="Shadow" then actualRole="CASTER" end end
	
	if classe=="Death Knight" then if spec=="Blood" then actualRole="TANK" end end
	if classe=="Death Knight" then if spec=="Frost" then actualRole="MELEE" end end
	if classe=="Death Knight" then if spec=="Unholy" then actualRole="MELEE" end end
	
	if classe=="Rogue" then if spec=="Assassination" then actualRole="MELEE" end end
	if classe=="Rogue" then if spec=="Combat" then actualRole="MELEE" end end
	if classe=="Rogue" then if spec=="Subtlety" then actualRole="MELEE" end end
	
	if classe=="Hunter" then if spec=="Beast Mastery" then actualRole="RANGED" end end
	if classe=="Hunter" then if spec=="Marksmanship" then actualRole="RANGED" end end
	if classe=="Hunter" then if spec=="Survival" then actualRole="RANGED" end end
	
	if classe=="Warrior" then if spec=="Arms" then actualRole="MELEE" end end
	if classe=="Warrior" then if spec=="Fury" then actualRole="MELEE" end end
	if classe=="Warrior" then if spec=="Protection" then actualRole="TANK" end end
	
	if classe=="Warlock" then if spec=="Affliction" then actualRole="CASTER" end end
	if classe=="Warlock" then if spec=="Demonology" then actualRole="CASTER" end end
	if classe=="Warlock" then if spec=="Destruction" then actualRole="CASTER" end end
	
	if classe=="Shaman" then if spec=="Elemental" then actualRole="CASTER" end end
	if classe=="Shaman" then if spec=="Enhancement" then actualRole="MELEE" end end
	if classe=="Shaman" then if spec=="Restoration" then actualRole="HEALER" end end
	
	if classe=="Druid" then if spec=="Balance" then actualRole="CASTER" end end
	if classe=="Druid" then if spec=="Feral Combat" then actualRole="TANK" end end
	if classe=="Druid" then if spec=="Restoration" then actualRole="HEALER" end end
	
	if classe=="Mage" then if spec=="Arcane" then actualRole="CASTER" end end
	if classe=="Mage" then if spec=="Fire" then actualRole="CASTER" end end
	if classe=="Mage" then if spec=="Frost" then actualRole="CASTER" end end
	
	return actualRole
end
-- // FUNZIONE CHE ASSEGNA PER OGNI TIPOLOGIA DI GIOCATORE LE STAT DA VISUALIZZARE
--************************************************************************************************** DA COMPLETARE!!!!!!!!!!!!!!!!!!
function readStats(role,stat)
	local LDBTesto, LDBIcona, LDBPopupTesto
	LDBTesto="Errore"
	LDBIcona=DEFAULT_ICON
	LDBPopupTesto="Errore nella lettura delle Stat..."
	-- SE SONO TANK
	if role=="TANK" then
		if stat=="1" then
			-- VISUALIZZO L'ARMOR
			LDBIcona="Interface\\Icons\\Spell_DeathKnight_BladedArmor"
			local base, effectiveArmor, armor, posBuff, negBuff = UnitArmor("player")
			local Melee_Reduction = effectiveArmor
			LDBTesto=string.format("A: %.0f", Melee_Reduction)
		else
			-- VISUALIZZO DODGE
			LDBIcona="Interface\\Icons\\Spell_Shadow_ShadowWard"
			LDBTesto=string.format("Dod: %.2f%%", GetDodgeChance())
		end	
	end
	-- SE SONO HEALER 
	if role=="HEALER" then
		if stat=="1" then
			-- VISUALIZZO SP Healing
			LDBIcona="Interface\\Icons\\Spell_Holy_Heal"
			LDBTesto=string.format("SP: %.0f", GetSpellBonusHealing("player"))
		else
			-- VISUALIZZO Haste
			LDBIcona="Interface\\Icons\\Spell_Arcane_Arcane04"
			local Total_Spell_Haste = GetCombatRating("20")
			LDBTesto="H: " .. Total_Spell_Haste
			-- Queste 2 righe visualizzano Haste %
			--local Total_Spell_Haste = GetCombatRatingBonus("20")
			--LDBTesto=string.format("H: %.2f%%", Total_Spell_Haste)
		end	
	end
	-- SE SONO CASTER
	if role=="CASTER" then
		if stat=="1" then
			-- VISUALIZZO SP a seconda della spec ... 
			
			-- Default Shadow DMG
			LDBIcona="Interface\\Icons\\Spell_Shadow_DeathCoil"
			LDBTesto=string.format("SP: %.0f", GetSpellBonusDamage("6"))
			local s =GetTalentText(GetActiveTalentGroup())
			if s=="Arcane" then 
			LDBIcona="Interface\\Icons\\Spell_Arcane_Blast"
			LDBTesto=string.format("SP: %.0f", GetSpellBonusDamage("7"))
			end
			if s=="Fire" then 
			LDBIcona="Interface\\Icons\\Spell_Fire_FireBall02"
			LDBTesto=string.format("SP: %.0f", GetSpellBonusDamage("3"))
			end
			if s=="Frost" then 
			LDBIcona="Interface\\Icons\\Spell_Frost_FrostBolt02"
			LDBTesto=string.format("SP: %.0f", GetSpellBonusDamage("5"))
			end
			if s=="Shadow" then 
			LDBIcona="Interface\\Icons\\Spell_Shadow_DeathCoil"
			LDBTesto=string.format("SP: %.0f", GetSpellBonusDamage("6"))
			end
			if s=="Balance" then 
			LDBIcona="Interface\\Icons\\Spell_Nature_Lightning"
			LDBTesto=string.format("SP: %.0f", GetSpellBonusDamage("4"))
			end
			if s=="Elemental" then 
			LDBIcona="Interface\\Icons\\Spell_Nature_Lightning"
			LDBTesto=string.format("SP: %.0f", GetSpellBonusDamage("4"))
			end
		else
			-- VISUALIZZO Haste
			LDBIcona="Interface\\Icons\\Spell_Arcane_Arcane04"
			local Total_Spell_Haste = GetCombatRating("20")
			LDBTesto="H: " .. Total_Spell_Haste
			-- Queste 2 righe visualizzano Haste %
			--local Total_Spell_Haste = GetCombatRatingBonus("20")
			--LDBTesto=string.format("H: %.2f%%", Total_Spell_Haste)
		end	
	end
	-- SE SONO MELEE
	if role=="MELEE" then
		if stat=="1" then
			-- VISUALIZZO Attack Power
			LDBIcona="Interface\\Icons\\Ability_MeleeDamage"
			local base, posBuff, negBuff = UnitAttackPower("player")
			local Melee_AP = base + posBuff + negBuff
			LDBTesto="AP: " .. Melee_AP
		else
			-- VISUALIZZO ARP
			LDBIcona="Interface\\Icons\\Ability_Hunter_PiercingShots"
			LDBTesto="ARP: " .. GetCombatRating("25")
			-- Queste 2 righe visualizzano Haste %
			--local Total_Spell_Haste = GetCombatRatingBonus("20")
			--LDBTesto=string.format("H: %.2f%%", Total_Spell_Haste)
		end	
	end
	-- SE SONO RANGED
	if role=="RANGED" then
		if stat=="1" then
			-- VISUALIZZO Attack Power
			LDBIcona="Interface\\Icons\\Ability_MeleeDamage"
			local base, posBuff, negBuff = UnitAttackPower("player")
			local Melee_AP = base + posBuff + negBuff
			LDBTesto="AP: " .. Melee_AP
		else
			-- VISUALIZZO Melee Haste
			LDBIcona="Interface\\Icons\\Ability_Rogue_SliceDice"
			local Total_Melee_Haste = GetCombatRatingBonus("18")
			LDBTesto=string.format("H: %.2f%%", Total_Melee_Haste)
			-- Queste 2 righe visualizzano Haste %
			--local Total_Spell_Haste = GetCombatRatingBonus("20")
			--LDBTesto=string.format("H: %.2f%%", Total_Spell_Haste)
		end	
	end
	
	return LDBTesto,LDBIcona,LDBPopupTesto
end

-- Funzione che Sceglie le 2 Stats da visualizzare 
-- HEALER : SP e Haste
-- Tank : Armor e dodge
-- Caster : SP e Haste
-- Melee : AP
-- Ranged : AP

-- // FUNZIONI DI PREPARAZIONE DI PEZZI DI POPUP
function IntestazionePopUp()
		GameTooltip:AddLine("|cffff8020Active Spec:|r " .. GetTalentText(GetActiveTalentGroup()))
		--GameTooltip:AddLine("----------------------------------------------------")
		GameTooltip:AddLine("|cffff8020Active Role:|r " .. GetRole("player"))
		--GameTooltip:AddLine("----------------------------------------------------")
		--GameTooltip:AddLine("|cffff8020Monitored Stats:|r ")		
end

function addHealingPopUP()	

		local Sp,Iconsp, Haste, IconHaste, Crit,IconCrit, Mp5, IconMp5, HastePerc, IconHastePerc

		Iconsp="Interface\\Icons\\Spell_Holy_Heal"
		IconHaste="Interface\\Icons\\Spell_Arcane_Arcane04"
		IconHastePerc="Interface\\Icons\\Spell_Arcane_Arcane04"
		IconCrit="Interface\\Icons\\Spell_Holy_HolyBolt"
		IconMp5="Interface\\Icons\\Spell_Magic_ManaGain"
		
		Sp=string.format("Spell Power: %.0f", GetSpellBonusHealing("player"))
		Haste="Haste: " .. GetCombatRating("20")
		HastePerc=string.format("%% Haste: %.2f%%", GetCombatRatingBonus("20"))
		Crit=string.format("%% Crit: %.2f%%",  GetSpellCritChance("2"))
		local base, casting = GetManaRegen()	
		local MP5_1 = (casting * 5)		
		Mp5=string.format("MP5: %.0f", MP5_1)

		GameTooltip:AddLine("|cffff8020-------------- HEALING STATISTICS ----------")
		GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", Iconsp, Sp))
		GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconHaste, Haste))
		GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconHastePerc, HastePerc))
		GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconCrit, Crit))
		GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconMp5, Mp5))
		
				
end

function addTankingPopUP()	

		local IconDef="Interface\\Icons\\Spell_Holy_LastingDefense"	
		local IconArmor="Interface\\Icons\\Spell_DeathKnight_BladedArmor"
		local IconDodge="Interface\\Icons\\Spell_Shadow_ShadowWard"	
		local IconParry="Interface\\Icons\\Ability_Parry"
		local IconBlock="Interface\\Icons\\Ability_Defend"
		
		local baseDefense, additionalDefense = UnitDefense("player")    
		local Defense = baseDefense + additionalDefense
		local base, effectiveArmor, armor, posBuff, negBuff = UnitArmor("player")
		
		local Def="Defence: "..Defense
		local Armor="Armor: "..effectiveArmor
		local Dodge=string.format("Dodge: %.2f%%", GetDodgeChance())
		local Parry=string.format("Parry: %.2f%%", GetParryChance())
		local Block=string.format("Block: %.2f%%", GetBlockChance())
		
		GameTooltip:AddLine("|cffff8020-------------- TANKING STATISTICS ----------")
		GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconDef, Def))
		GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconArmor, Armor))
		GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconDodge, Dodge))
		GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconParry, Parry))
		GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconBlock, Block))
		
				
end

function addCasterPopUP()	

local IconSPArcane="Interface\\Icons\\Spell_Arcane_Blast"
local IconSPNature="Interface\\Icons\\Spell_Nature_Lightning"
local IconSPFire="Interface\\Icons\\Spell_Fire_FireBall02"	
local IconSPFrost="Interface\\Icons\\Spell_Frost_FrostBolt02"
local IconSPHOLY="Interface\\Icons\\Spell_Holy_FlashHeal"
local IconSPSHADOW="Interface\\Icons\\Spell_Shadow_DeathCoil"
local IconCRITArcane="Interface\\Icons\\Spell_Arcane_Rune"	
local IconCRITNature="Interface\\Icons\\Spell_Nature_LightningOverload"
local IconCRITFire="Interface\\Icons\\Spell_Fire_FireBall"			
local IconCRITFrost="Interface\\Icons\\Spell_Frost_WizardMark"		
local IconCRITHOLY="Interface\\Icons\\Spell_Holy_HolyBolt"			
local IconCRITSHADOW="Interface\\Icons\\Spell_Shadow_ShadowWordPain"
local IconSpellHIT="Interface\\Icons\\Spell_ChargePositive"			
local IconSpellHASTE="Interface\\Icons\\Spell_Arcane_Arcane04"		
local IconMP5="Interface\\Icons\\Spell_Magic_ManaGain"				

local SPArcane=string.format("SP Arcane: %.0f", GetSpellBonusDamage("7"))
local SPNature=string.format("SP Nature: %.0f", GetSpellBonusDamage("4"))
local SPFire=string.format("SP Fire: %.0f", GetSpellBonusDamage("3"))
local SPFrost=string.format("SP Frost: %.0f", GetSpellBonusDamage("5"))
local SPHOLY=string.format("SP Holy: %.0f", GetSpellBonusDamage("2"))
local SPSHADOW=string.format("SP Shadow: %.0f", GetSpellBonusDamage("6"))
local CRITArcane=string.format("%% CRIT Arcane: %.2f%%", GetSpellCritChance("7"))
local CRITNature=string.format("%% CRIT Arcane: %.2f%%", GetSpellCritChance("4"))
local CRITFire=string.format("%% CRIT Arcane: %.2f%%", GetSpellCritChance("3"))
local CRITFrost=string.format("%% CRIT Arcane: %.2f%%", GetSpellCritChance("5"))
local CRITHOLY=string.format("%% CRIT Arcane: %.2f%%", GetSpellCritChance("2"))
local CRITSHADOW=string.format("%% CRIT Arcane: %.2f%%", GetSpellCritChance("6"))
local SpellHIT=string.format("%% HIT: %.2f%%",GetCombatRatingBonus("8"))
local SpellHASTE=string.format("%% HASTE: %.2f%%", GetCombatRatingBonus("20"))	
local base, casting = GetManaRegen()	
local MP5_1 = (casting * 5)	
local MP5=string.format("MP5: %.0f", MP5_1)
	
GameTooltip:AddLine("|cffff8020-------------- CASTERS SP STATISTICS ------------")
GameTooltip:AddLine(format("\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconSPArcane, SPArcane))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconSPNature, SPNature))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconSPFire, SPFire))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconSPFrost, SPFrost))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconSPHOLY, SPHOLY))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconSPSHADOW, SPSHADOW))
GameTooltip:AddLine("|cffff8020-------------- CASTERS CRIT STATISTICS ----------")
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconCRITArcane, CRITArcane))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconCRITNature, CRITNature))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconCRITFire, CRITFire))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconCRITFrost, CRITFrost))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconCRITHOLY, CRITHOLY))		
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconCRITSHADOW, CRITSHADOW))
GameTooltip:AddLine("|cffff8020-------------- CASTERS SPEED STATISTICS ----------")
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconSpellHIT, SpellHIT))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconSpellHASTE, SpellHASTE))		
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconMP5, MP5))
				
end

function addRangedPopUP()	

local IconARPperc="Interface\\Icons\\Ability_Hunter_PiercingShots"
local IconARP="Interface\\Icons\\Ability_Hunter_PiercingShots"
local IconAP="Interface\\Icons\\Ability_Hunter_MasterMarksman"
local IconHIT="Interface\\Icons\\Spell_ChargePositive"		
local IconCrit="Interface\\Icons\\Ability_Hunter_Assassinate2"
local IconHaste="Interface\\Icons\\Ability_Druid_Dash"		
local IconSpeed="Interface\\Icons\\Inv_weapon_bow_01"

local ARPperc=string.format("%% Armor Penetration: %.2f%%", GetCombatRatingBonus("25"))	
local ARP="Armor Penetration: "..GetCombatRating("25")
local base, posBuff, negBuff = UnitRangedAttackPower("player")		
local Attack=base + posBuff + negBuff
local AP="Attack Power: ".. Attack
local HIT=string.format("%% Hit: %.2f%%", GetCombatRatingBonus("7"))													
local Crit=string.format("%% Crit: %.2f%%", GetRangedCritChance("25"))	
local Haste=string.format("%% Haste: %.2f%%", GetCombatRatingBonus("19"))	
local speed = UnitRangedDamage("player")	
local Total_Range_Speed = speed		
local Speed=string.format("Speed: %.2f", Total_Range_Speed)	

GameTooltip:AddLine("|cffff8020-------------- RANGED STATISTICS ------------")
GameTooltip:AddLine(format("\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconARPperc, ARPperc))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconARP, ARP))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconAP, AP))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconHIT, HIT))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconCrit, Crit))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconHaste, Haste))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconSpeed, Speed))
end

function addMeleePopUP()

local IconMeleeAP="Interface\\Icons\\Ability_MeleeDamage"		
local IconMeleeCrit= "Interface\\Icons\\Ability_Warrior_ShieldBreak"
local IconExpertise="Interface\\Icons\\Ability_Warrior_Challange"
local IconExpertisePerc="Interface\\Icons\\Ability_Warrior_Challange"
local IconARP="Interface\\Icons\\Ability_Hunter_PiercingShots"
local IconHIT="Interface\\Icons\\Spell_ChargePositive"			
local IconHITPerc="Interface\\Icons\\Spell_ChargePositive"			
local IconHASTE="Interface\\Icons\\Ability_Rogue_SliceDice"		
local IconHASTEPerc="Interface\\Icons\\Ability_Rogue_SliceDice"		
local IconWEAPSPEED="Interface\\Icons\\Ability_steelmelee"			

local base, posBuff, negBuff = UnitAttackPower("player")	
local Melee_AP = base + posBuff + negBuff
local MeleeAP="AP: "..Melee_AP
local MeleeCrit=string.format("%.2f%%", GetCritChance("player"))
local Expertise="Expertise: "..GetCombatRating("24")
local ExpertisePerc=string.format("Expertise: %.2f%%", GetCombatRatingBonus("24"))
local ARP=string.format("Armor Penetration: %.2f%%", GetCombatRatingBonus("25"))
local HIT="Hit: "..GetCombatRating("6")
local HITPerc=string.format("%% Hit: %.2f%%", GetCombatRatingBonus("6"))
local HASTE="Haste: "..GetCombatRating("18")			
local HASTEPerc=string.format("%% Haste: %.2f%%", GetCombatRatingBonus("18"))			
local mainSpeed, offSpeed = UnitAttackSpeed("player");
local WEAPSPEED= "Weap.Speed: "
if offSpeed ~=nil then
WEAPSPEED=string.format("Weap.Speed: Main %.2f - Off %.2f",mainSpeed,offSpeed)
else
WEAPSPEED=string.format("Weap.Speed: Main %.2f",mainSpeed)
end

GameTooltip:AddLine("|cffff8020-------------- MELEE STATISTICS ------------")
GameTooltip:AddLine(format("\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconMeleeAP, MeleeAP))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconMeleeCrit, MeleeCrit))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconExpertise, Expertise))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconExpertisePerc, ExpertisePerc))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconARP, ARP))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconHIT, HIT))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconHITPerc, HITPerc))
GameTooltip:AddLine(format("\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconHASTE, HASTE))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconHASTEPerc, HASTEPerc))
GameTooltip:AddLine(format( "\124T%s:19:19:0:0:25:25:2:23:2:23\124t %s", IconWEAPSPEED, WEAPSPEED))

end
--[[

STATS DA VISUALIZZARE : 

TANK : 

Defense		"Interface\\Icons\\Spell_Holy_LastingDefense"				local baseDefense, additionalDefense = UnitDefense("player")    local Defense = baseDefense + additionalDefense
Armor		"Interface\\Icons\\Spell_DeathKnight_BladedArmor"			local base, effectiveArmor, armor, posBuff, negBuff = UnitArmor("player")
Dodge		"Interface\\Icons\\Spell_Shadow_ShadowWard"					GetDodgeChance()
Parry		"Interface\\Icons\\Ability_Parry"							GetParryChance()
Block		"Interface\\Icons\\Ability_Defend"							GetBlockChance()

MELEE : 

Melee AP	"Interface\\Icons\\Ability_MeleeDamage"						local base, posBuff, negBuff = UnitAttackPower("player")	local Melee_AP = base + posBuff + negBuff
Melee Crit  "Interface\\Icons\\Ability_Warrior_ShieldBreak"				string.format("%.2f%%", GetCritChance("player"))
Expertise	"Interface\\Icons\\Ability_Warrior_Challange"				string.format("%.2f%%", GetCombatRatingBonus("24"))
ARP			"Interface\\Icons\\Ability_Hunter_PiercingShots"			string.format("%.2f%%", GetCombatRatingBonus("25"))
HIT			"Interface\\Icons\\Spell_ChargePositive"					string.format("%.2f%%", GetCombatRatingBonus("6"))
HASTE		"Interface\\Icons\\Ability_Rogue_SliceDice"					GetCombatRatingBonus("18")			
WEAP SPEED	"Interface\\Icons\\Ability_steelmelee"						local mainSpeed, offSpeed = UnitAttackSpeed("player");		string.format("%.2f - %.2f",mainSpeed,offSpeed)

CASTERS : 

SP Arcane	"Interface\\Icons\\Spell_Arcane_Blast"						GetSpellBonusDamage("7")
SP Nature	"Interface\\Icons\\Spell_Nature_Lightning"					GetSpellBonusDamage("4")
SP Fire		"Interface\\Icons\\Spell_Fire_FireBall02"					GetSpellBonusDamage("3")
SP Frost	"Interface\\Icons\\Spell_Frost_FrostBolt02"					GetSpellBonusDamage("5")
SP HOLY		"Interface\\Icons\\Spell_Holy_FlashHeal"					GetSpellBonusDamage("2")
SP SHADOW	"Interface\\Icons\\Spell_Shadow_DeathCoil"					GetSpellBonusDamage("6")

CRIT Arcane	"Interface\\Icons\\Spell_Arcane_Rune"						string.format("%.2f%%", GetSpellCritChance("7"))
CRIT Nature	"Interface\\Icons\\Spell_Nature_LightningOverload"			string.format("%.2f%%", GetSpellCritChance("4"))
CRIT Fire	"Interface\\Icons\\Spell_Fire_FireBall"						string.format("%.2f%%", GetSpellCritChance("3"))
CRIT Frost	"Interface\\Icons\\Spell_Frost_WizardMark"					string.format("%.2f%%", GetSpellCritChance("5"))
CRIT HOLY	"Interface\\Icons\\Spell_Holy_HolyBolt"						string.format("%.2f%%", GetSpellCritChance("2"))
CRIT SHADOW	"Interface\\Icons\\Spell_Shadow_ShadowWordPain"				string.format("%.2f%%", GetSpellCritChance("6"))

Spell HIT	"Interface\\Icons\\Spell_ChargePositive"					string.format("%.2f%%",GetCombatRatingBonus("8"))
Spell HASTE	"Interface\\Icons\\Spell_Arcane_Arcane04"					string.format("%.2f%%", GetCombatRatingBonus("20"))	

MP5			"Interface\\Icons\\Spell_Magic_ManaGain"					local base, casting = GetManaRegen()	local MP5_1 = (casting * 5)		string.format("%.0f", MP5_1)

RANGED : 

ARP			"Interface\\Icons\\Ability_Hunter_PiercingShots"			string.format("%.2f%%", GetCombatRatingBonus("25"))	
AP			"Interface\\Icons\\Ability_Hunter_MasterMarksman"			local base, posBuff, negBuff = UnitRangedAttackPower("player")		local Range_AP = base + posBuff + negBuff
HIT			"Interface\\Icons\\Spell_ChargePositive"					string.format("%.2f%%", GetCombatRatingBonus("7"))													
Crit		"Interface\\Icons\\Ability_Hunter_Assassinate2"				string.format("%.2f%%", GetRangedCritChance("25"))	
Haste		"Interface\\Icons\\Ability_Druid_Dash"						string.format("%.2f%%", GetCombatRatingBonus("19"))	
Speed		"Interface\\Icons\\Inv_weapon_bow_01"						local speed = UnitRangedDamage("player")	local Total_Range_Speed = speed		string.format("%.2f", Total_Range_Speed)	
]]


-- Creazione del Frame e Impostazione dei dati visualizzati
local Main=CreateFrame"Frame"
local Secondary=CreateFrame"Frame"

Main:SetFrameStrata("BACKGROUND")
Main:SetScript("OnUpdate", UpdateStatsM)

Secondary:SetFrameStrata("BACKGROUND")
Secondary:SetScript("OnUpdate", UpdateStatsS)


